/**********************************************************************************
** Split Studio v1.1 (22.6.2000)
** (c) by Gian Davide Alfano
** This program is FREEWARE
** For any question, suggestion, donation(?) write to:
** alfagiandy@libero.it
** http://digilander.iol.it
**
** Portions of code generated by BeBuilder Release V0.5.2                
** Written by Jerome Fillon (Softimedia Inc.)
**
** This program is free software; you can redistribute it and/or 
** modify it under the terms of the GNU General Public License 
** as published by the Free Software Foundation; either version 2 
** of the License, or (at your option) any later version. 
**
** This program is distributed in the hope that it will be useful, 
** but WITHOUT ANY WARRANTY; without even the implied warranty of 
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
** GNU General Public License for more details. 
**
** You should have received a copy of the GNU General Public License 
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** HISTORY
** 1.0 (17.6.00) : first release
** 1.1 (22.6.00) : Now SplitStudio is a complete and standalone program
**				   It is a complete shell command with a nice GUI (see docs
**				   	about the arguments)
**				   Removed the Prefix TextControl (SplitStudio creates more 
**				   	significant file names :-))
**				   Added a Parts item to the Unit menu as starting with 1.1
**					you can specify the parts the source file will be splitted in
**
**********************************************************************************/

#ifndef __TBoxSplit_H__ 
#define __TBoxSplit_H__ 
#include <MenuBar.h>
#include <Rect.h>
#include <Button.h>
#include <TextControl.h>
#include <TextControl.h>
#include <Box.h>
#include <PopUpMenu.h>
#include <MenuField.h>
#include <MenuItem.h>
#include <FilePanel.h>
#include <Alert.h>

#define REBUILD 1
#define SPLIT 0

#define SN_SELECT 'LECT'
#define SN_GO 'N_GO'
#define SN_PATH 'PATH'
#define SN_PREFIX 'EFIX'
#define SN_DIR '_DIR'
#define SN_DIR_SEL '_SEL'
#define SN_SIZE 'SIZE'
#define SN_SIZE_144 '_144'
#define SN_SIZE_720 '_720'
#define SN_SIZE_CUSTOM 'CUST'
#define SN_REBUILD 'UILD'
#define SN_SPLIT 'PLIT'
#define SN_BYTES 'YTES'
#define SN_KILOS 'ILOS'
#define SN_MEGS 'MEGS'
#define SN_PARTS 'ARTS'
#define SN_ABOUT 'BOUT'
#define DESTDIR 'TDIR'

#define K 1024
#define SIZE_720 720
#define SIZE_144 144
#define SIZE_280 280

class fMenuItem : public BMenuItem {
	public:
		fMenuItem(const char *name, BMessage *message, uint32 size=0, int mode=SPLIT, char unit='b');
		uint32 size;
		int mode;
		char unit;
};

class TBoxSplit: public BBox
{
	public:
		uint32 current_size;
		char current_unit;
		int current_mode;
		char sourcefile[B_FILE_NAME_LENGTH];
		char destdir[B_FILE_NAME_LENGTH];
		char current_prefix[B_FILE_NAME_LENGTH];
		
		BPopUpMenu *fSize;
		BPopUpMenu *fMode;
		BPopUpMenu *fUnit;
		BMenuField *field;
		
		BButton *FAButtonSelect;
		BButton *FAButtonGo;
		BButton *FAButtonAbout;
		BButton *FAButtonDir;
		
		BTextControl *FATextControlPath;
		BTextControl *FATextControlSize;
		BTextControl *FATextControlDir;
		BTextControl *FATextControlPrefix;
		
		BListView *FAListView;
		BScrollView *FAScrollView;
		
		BFilePanel *fOpenPanel, *fSavePanel, *fDirPanel;
				
		TBoxSplit(BRect AFrame);
		~TBoxSplit(void);
		void MessageReceived(BMessage *message);
		void AttachedToWindow(void);
		void DoSizeMenu(void);
		void DoModeMenu(void);
		void DoUnitMenu(void);
		void DoFilePanel(void);
		void SetSizeMenu(void);
		void SetUnitMenu(void);
		BView *SetModeMenu(void);
		void MsgBox(char *str, char *button, alert_type type = B_IDEA_ALERT);

};
#endif
