/**********************************************************************************
** Split Studio v1.1 (22.6.2000)
** (c) by Gian Davide Alfano
** This program is FREEWARE
** For any question, suggestion, donation(?) write to:
** alfagiandy@libero.it
** http://digilander.iol.it
**
** Portions of code generated by BeBuilder Release V0.5.2                
** Written by Jerome Fillon (Softimedia Inc.)
**
** This program is free software; you can redistribute it and/or 
** modify it under the terms of the GNU General Public License 
** as published by the Free Software Foundation; either version 2 
** of the License, or (at your option) any later version. 
**
** This program is distributed in the hope that it will be useful, 
** but WITHOUT ANY WARRANTY; without even the implied warranty of 
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
** GNU General Public License for more details. 
**
** You should have received a copy of the GNU General Public License 
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** HISTORY
** 1.0 (17.6.00) : first release
** 1.1 (22.6.00) : Now SplitStudio is a complete and standalone program
**				   It is a complete shell command with a nice GUI (see docs
**				   	about the arguments)
**				   Removed the Prefix TextControl (SplitStudio creates more 
**				   	significant file names :-))
**				   Added a Parts item to the Unit menu as starting with 1.1
**					you can specify the parts the source file will be splitted in
**
**********************************************************************************/

#include <StorageKit.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <String.h>

#include "ASplitStudio.h"
#include "AWindow.h"
#include "dosplit.h"

BWindow *MyWin; // Global to allow other class to PostMessage()

TBeBuilderApp::TBeBuilderApp() : BApplication("application/x-vnd.SplitStudio")
{
	BRect ARectAWindow(269.000000,207.000000,662.000000,374.000000);
	FAWindow = new TWindow("Split Studio v1.1",ARectAWindow);
	FAWindow->SetSizeLimits(300,800,167,167);
	FAWindow->Show();
	MyWin = FAWindow;
}

// If we are called from the addon we are given the B_REFS_MESSAGE
void TBeBuilderApp::RefsReceived(BMessage *msg)
{
	FAWindow->PostMessage(msg,FAWindow->AView);
}

int main(int argc, char*argv[])
{
	int i, err;
	size_t splitsize=10000;
	bool rebuild=false;
	char destdir[B_FILE_NAME_LENGTH], filename[B_FILE_NAME_LENGTH], destname[B_FILE_NAME_LENGTH];
	char unit = 'b';
	
	printf("SplitStudio v1.1 by GianDavide Alfano 2000\n");
	
	if (argc<=1) {
		TBeBuilderApp MyApp;
		MyApp.Run();
		return 0;
	}
	
	strcpy(filename,argv[1]);
	BPath filepath(filename);
	strcpy(destdir,".");
	
	for(i=1;i<argc;i++) {
		BString arg = argv[i];
		if (arg.ICompare("REBUILD")==0) rebuild=true;
		if (arg.ICompare("SIZE")==0) splitsize=atol(argv[++i]);
		if (arg.ICompare("KB")==0) unit='k';
		if (arg.ICompare("MB")==0) unit='m';
		if (arg.ICompare("PARTS")==0) unit='p';
		if (arg.ICompare("PATH")==0) sprintf(destdir,"%s",argv[++i]);
		if ( (arg.ICompare("?")==0) || (arg.ICompare("--HELP")==0) )
		{
			printf("SplitStudio filename [REBUILD|SIZE filesize [KB|MB|PARTS]] [PATH destdir]\n");// [PREFIX prefix]
			return 0;
		}
	}
	
	if (strcmp(destdir,"")!=0)
	{
		BDirectory dir(destdir);
		if (dir.InitCheck()==B_ENTRY_NOT_FOUND)
		{
			printf("%s non è un percorso valido. Scrivo nella cartella corrente.\n",destdir);
			sprintf(destdir,".");
		}
	}
	
	if (rebuild)
	{
		BFile sorg(filepath.Path(),B_READ_ONLY);
		if (sorg.InitCheck()!=B_OK)
		{
			printf("File doesn't exist\n");
			return 1;
		}
		if (sorg.ReadAttr("SPLITSTUDIO",NULL,NULL,destname,B_FILE_NAME_LENGTH)==B_ENTRY_NOT_FOUND)
		{
			printf("This file has not been created by SplitStudio\n");
			return 1;
		}
		sorg.ReadAttr("FILENAME",NULL,NULL,destname,B_FILE_NAME_LENGTH);
		sorg.ReadAttr("PARTS",NULL,NULL,&splitsize,sizeof(splitsize));
		sorg.Unset();
		err = dorebuild((char *)filepath.Path(),destdir,destname,(int)splitsize);
	} else 
	{
		err = dosplit(filepath, destdir, splitsize, unit);
	}
	
	switch (err)
	{
		case ERR_OPEN_DEST_FILE:
			printf("Could not open %s/%s\n",destdir,destname);
			break;
		case ERR_OPEN_REBUILD_FILE:
			printf("One of the file parts is missing or cannot be opened\n");
			break;
		case ERR_OPEN_FILE:
			printf("Could not open %s\n",filepath.Path());
			break;
		case ERR_FILE_TOO_SMALL:
			puts("File too small to be splitted!");
			break;
		case ERR_WRITING:
			printf("Error reading %s\n",filepath.Path());
			break;
		case ERR_READING:
			puts("Error splitting file\n");
			break;
		case DONE_SPLIT:
		case DONE_REBUILD:
			puts("Work done.\n");
			break;
		case ERR_SPLIT_FILE:
			printf("%s is not a SplitStudio generated file.\n",filepath.Path());
			break;
	}
}