/**********************************************************************************
** Split Studio v1.1 (22.6.2000)
** (c) by Gian Davide Alfano
** This program is FREEWARE
** For any question, suggestion, donation(?) write to:
** alfagiandy@libero.it
** http://digilander.iol.it
**
** Portions of code generated by BeBuilder Release V0.5.2                
** Written by Jerome Fillon (Softimedia Inc.)
**
** This program is free software; you can redistribute it and/or 
** modify it under the terms of the GNU General Public License 
** as published by the Free Software Foundation; either version 2 
** of the License, or (at your option) any later version. 
**
** This program is distributed in the hope that it will be useful, 
** but WITHOUT ANY WARRANTY; without even the implied warranty of 
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
** GNU General Public License for more details. 
**
** You should have received a copy of the GNU General Public License 
** along with this program; if not, write to the Free Software 
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
**
** HISTORY
** 1.0 (17.6.00) : first release
** 1.1 (22.6.00) : Now SplitStudio is a complete and standalone program
**				   It is a complete shell command with a nice GUI (see docs
**				   	about the arguments)
**				   Removed the Prefix TextControl (SplitStudio creates more 
**				   	significant file names :-))
**				   Added a Parts item to the Unit menu as starting with 1.1
**					you can specify the parts the source file will be splitted in
**
**********************************************************************************/

#include <StorageKit.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <String.h>

#include "dosplit.h"

void strip(char *str)
{
	BString string = str;
	int32 ch = string.FindLast(".s");
	string.Truncate(ch+2);
	strcpy(str,string.String());
}

int dorebuild(char *filename, char *destdir, char *origname, int parti)
{
	int n;
	size_t filesize=0, letti;
	BString oldname;
	BPath newname;
	char *buffer;
	
	newname.SetTo(destdir,origname);
	BFile dest(newname.Path(),B_READ_WRITE | B_CREATE_FILE | B_ERASE_FILE);
	if (dest.InitCheck()!=B_OK)
		return ERR_OPEN_DEST_FILE;
	puts(newname.Path());
	strip(filename);
	for (n=1;n<=parti;n++)
	{
		oldname.SetTo(filename);
		oldname << n;
		puts(oldname.String());
		BFile sorg(oldname.String(),B_READ_ONLY);
		if (sorg.InitCheck()!=B_OK)
			return ERR_OPEN_REBUILD_FILE;
		sorg.GetSize((off_t *)&filesize);
		buffer = new char[filesize];
		if ((letti = sorg.Read((void *)buffer,filesize))<0)
			return ERR_READING;
		if (dest.Write((void *)buffer,letti)<0)
			return ERR_WRITING;
		sorg.Unset();
	}
	dest.Unset();
	return DONE_REBUILD;
}

int dosplit(BPath &filepath, char *destdir, size_t splitsize = 0, char unit = 'b')
{
	int n, parti;
	size_t filesize=0;
	char destname[B_FILE_NAME_LENGTH];
		

	BFile sorg(filepath.Path(),B_READ_ONLY);
	if (sorg.InitCheck()!=B_OK)
		return ERR_OPEN_FILE;
	sorg.GetSize((off_t *)&filesize);

	if (filesize<splitsize)
		return ERR_FILE_TOO_SMALL;
	parti = (int)(filesize/splitsize)+1;
	if ((filesize%splitsize)==0) parti--;
	size_t letti, scritti;
	
	switch (unit)
	{
		case 'm' : splitsize = splitsize*1024; 
		case 'k' : splitsize = splitsize*1024;
			parti = (int)(filesize/splitsize)+1;
			if ((filesize%splitsize)==0) parti--;
			break;
		case 'p' : 
			parti = splitsize;
			splitsize = (filesize/parti)+1; 
			break;
	}
	
	char *buffer = new char[splitsize];
	
	for (n=1;n<=parti;n++)
	{
		if ((letti = sorg.Read((void *)buffer,splitsize))<0)
			return ERR_READING;
		BString tmp = filepath.Leaf();
		tmp << ".s" << n;
		BPath dirname(destdir,tmp.String(),true);
		sprintf(destname,"%s",dirname.Path());
		
		BFile dest(destname, B_READ_WRITE | B_CREATE_FILE | B_ERASE_FILE);
		if ((scritti=dest.Write((void *)buffer,letti))<0)
			return ERR_WRITING;
		dest.WriteAttr("SPLITSTUDIO",B_STRING_TYPE,0,"1.1",strlen("1.1"));
		dest.WriteAttr("FILENAME",B_STRING_TYPE,0,filepath.Leaf(),strlen(filepath.Leaf()));
		dest.WriteAttr("PARTS",B_INT32_TYPE,0,&parti,sizeof(parti));
		dest.WriteAttr("ORIGSIZE",B_INT32_TYPE,0,&filesize,sizeof(filesize));
		
		dest.Unset();
	}

	sorg.Unset();
	delete buffer;
	return DONE_SPLIT;
}	
